; Note: This file is included for reference only and is not needed for
; recompiling the program.

; (The instruction table is split into three in the actual binary)


; 6502/6510 instruction set:

        .DB     $69,$03,$01     ; ADC #$10      Immediate
        .DB     $65,$03,$02     ; ADC $10       Zero page
        .DB     $75,$03,$03     ; ADC $10,x     Zero page,x
        .DB     $6d,$03,$04     ; ADC $1000     Absolute
        .DB     $7d,$03,$05     ; ADC $1000,x   Absolute,x
        .DB     $79,$03,$06     ; ADC $1000,y   Absolute,y
        .DB     $61,$03,$07     ; ADC ($10,x)   (Indirect,x)
        .DB     $71,$03,$08     ; ADC ($10),y   (Indirect),y

        .DB     $29,$06,$01     ; AND #$10      Immediate
        .DB     $25,$06,$02     ; AND $10       Zero page
        .DB     $35,$06,$03     ; AND $10,x     Zero page,x
        .DB     $2d,$06,$04     ; AND $1000     Absolute
        .DB     $3d,$06,$05     ; AND $1000,x   Absolute,x
        .DB     $39,$06,$06     ; AND $1000,y   Absolute,y
        .DB     $21,$06,$07     ; AND ($10,x)   (Indirect,x)
        .DB     $31,$06,$08     ; AND ($10),y   (Indirect),y

        .DB     $0a,$09,$00     ; ASL           Implied/Accu
        .DB     $06,$09,$02     ; ASL $10       Zero page
        .DB     $16,$09,$03     ; ASL $10,x     Zero page,x
        .DB     $0e,$09,$04     ; ASL $1000     Absolute
        .DB     $1e,$09,$05     ; ASL $1000,x   Absolute,x

        .DB     $90,$0c,$09     ; BCC $1000     Relative
        .DB     $B0,$0f,$09     ; BCS $1000     Relative
        .DB     $F0,$12,$09     ; BEQ $1000     Relative

        .DB     $24,$15,$02     ; BIT $00       Zero page
        .DB     $2C,$15,$04     ; BIT $0000     Absolute

        .DB     $30,$18,$09     ; BMI $1000     Relative
        .DB     $D0,$1b,$09     ; BNE $1000     Relative
        .DB     $10,$1e,$09     ; BPL $1000     Relative
        .DB     $00,$21,$00     ; BRK           Implied
        .DB     $50,$24,$09     ; BVC $1000     Relative
        .DB     $70,$27,$09     ; BVS $1000     Relative

        .DB     $18,$2a,$00     ; CLC           Implied
        .DB     $d8,$2d,$00     ; CLD           Implied
        .DB     $58,$30,$00     ; CLI           Implied
        .DB     $b8,$33,$00     ; CLV           Implied

        .DB     $c9,$36,$01     ; CMP #$10      Immediate
        .DB     $c5,$36,$02     ; CMP $10       Zero page
        .DB     $d5,$36,$03     ; CMP $10,x     Zero page,x
        .DB     $cd,$36,$04     ; CMP $1000     Absolute
        .DB     $dd,$36,$05     ; CMP $1000,x   Absolute,x
        .DB     $d9,$36,$06     ; CMP $1000,y   Absolute,y
        .DB     $c1,$36,$07     ; CMP ($10,x)   (Indirect,x)
        .DB     $d1,$36,$08     ; CMP ($10),y   (Indirect),y

        .DB     $e0,$39,$01     ; CPX #$10      Immediate
        .DB     $e4,$39,$02     ; CPX $10       Zero page
        .DB     $ec,$39,$04     ; CPX $1000     Absolute

        .DB     $c0,$3c,$01     ; CPY #$10      Immediate
        .DB     $c4,$3c,$02     ; CPY $10       Zero page
        .DB     $cc,$3c,$04     ; CPY $1000     Absolute

        .DB     $c6,$3f,$02     ; DEC $10       Zero page
        .DB     $d6,$3f,$03     ; DEC $10,x     Zero page,x
        .DB     $ce,$3f,$04     ; DEC $1000     Absolute
        .DB     $de,$3f,$05     ; DEC $1000,x   Absolute,x

        .DB     $ca,$42,$00     ; DEX           Implied
        .DB     $88,$45,$00     ; DEY           Implied

        .DB     $49,$48,$01     ; EOR #$10      Immediate
        .DB     $45,$48,$02     ; EOR $10       Zero page
        .DB     $55,$48,$03     ; EOR $10,x     Zero page,x
        .DB     $4d,$48,$04     ; EOR $1000     Absolute
        .DB     $5d,$48,$05     ; EOR $1000,x   Absolute,x
        .DB     $59,$48,$06     ; EOR $1000,y   Absolute,y
        .DB     $41,$48,$07     ; EOR ($10,x)   (Indirect,x)
        .DB     $51,$48,$08     ; EOR ($10),y   (Indirect),y

        .DB     $e6,$4b,$02     ; INC $10       Zero page
        .DB     $f6,$4b,$03     ; INC $10,x     Zero page,x
        .DB     $ee,$4b,$04     ; INC $1000     Absolute
        .DB     $fe,$4b,$05     ; INC $1000,x   Absolute,x

        .DB     $e8,$4e,$00     ; INX           Implied
        .DB     $c8,$51,$00     ; INY           Implied

        .DB     $4c,$54,$04     ; JMP $1000     Absolute
        .DB     $6c,$54,$0a     ; JMP ($1000)   Indirect
        .DB     $20,$57,$04     ; JSR $1000     Absolute

        .DB     $a9,$5a,$01     ; LDA #$10      Immediate
        .DB     $a5,$5a,$02     ; LDA $10       Zero page
        .DB     $b5,$5a,$03     ; LDA $10,x     Zero page,x
        .DB     $ad,$5a,$04     ; LDA $1000     Absolute
        .DB     $bd,$5a,$05     ; LDA $1000,x   Absolute,x
        .DB     $b9,$5a,$06     ; LDA $1000,y   Absolute,y
        .DB     $a1,$5a,$07     ; LDA ($10,x)   (Indirect,x)
        .DB     $b1,$5a,$08     ; LDA ($10),y   (Indirect),y

        .DB     $a2,$5d,$01     ; LDX #$10      Immediate
        .DB     $a6,$5d,$02     ; LDX $10       Zero page
        .DB     $b6,$5d,$0b     ; LDX $10,y     Zero page,y (!)
        .DB     $ae,$5d,$04     ; LDX $1000     Absolute
        .DB     $be,$5d,$06     ; LDX $1000,y   Absolute,y

        .DB     $a0,$60,$01     ; LDY #$10      Immediate
        .DB     $a4,$60,$02     ; LDY $10       Zero page
        .DB     $b4,$60,$03     ; LDY $10,x     Zero page,x
        .DB     $ac,$60,$04     ; LDY $1000     Absolute
        .DB     $bc,$60,$05     ; LDY $1000,x   Absolute,x

        .DB     $4a,$63,$00     ; LSR           Implied/Accu
        .DB     $46,$63,$02     ; LSR $10       Zero page
        .DB     $56,$63,$03     ; LSR $10,x     Zero page,x
        .DB     $4e,$63,$04     ; LSR $1000     Absolute
        .DB     $5e,$63,$05     ; LSR $1000,x   Absolute,x

        .DB     $ea,$66,$00     ; NOP           Implied

        .DB     $09,$69,$01     ; ORA #$10      Immediate
        .DB     $05,$69,$02     ; ORA $10       Zero page
        .DB     $15,$69,$03     ; ORA $10,x     Zero page,x
        .DB     $0d,$69,$04     ; ORA $1000     Absolute
        .DB     $1d,$69,$05     ; ORA $1000,x   Absolute,x
        .DB     $19,$69,$06     ; ORA $1000,y   Absolute,y
        .DB     $01,$69,$07     ; ORA ($10,x)   (Indirect,x)
        .DB     $11,$69,$08     ; ORA ($10),y   (Indirect),y

        .DB     $48,$6c,$00     ; PHA           Implied
        .DB     $08,$6f,$00     ; PHP           Implied
        .DB     $68,$72,$00     ; PLA           Implied
        .DB     $28,$75,$00     ; PLP           Implied

        .DB     $2a,$78,$00     ; ROL           Implied/Accu
        .DB     $26,$78,$02     ; ROL $10       Zero page
        .DB     $36,$78,$03     ; ROL $10,x     Zero page,x
        .DB     $2e,$78,$04     ; ROL $1000     Absolute
        .DB     $3e,$78,$05     ; ROL $1000,x   Absolute,x

        .DB     $6a,$7b,$00     ; ROR           Implied/Accu
        .DB     $66,$7b,$02     ; ROR $10       Zero page
        .DB     $76,$7b,$03     ; ROR $10,x     Zero page,x
        .DB     $6e,$7b,$04     ; ROR $1000     Absolute
        .DB     $7e,$7b,$05     ; ROR $1000,x   Absolute,x

        .DB     $4d,$7e,$00     ; RTI           Implied
        .DB     $60,$81,$00     ; RTS           Implied

        .DB     $e9,$84,$01     ; SBC #$10      Immediate
        .DB     $e5,$84,$02     ; SBC $10       Zero page
        .DB     $f5,$84,$03     ; SBC $10,x     Zero page,x
        .DB     $ed,$84,$04     ; SBC $1000     Absolute
        .DB     $fd,$84,$05     ; SBC $1000,x   Absolute,x
        .DB     $f9,$84,$06     ; SBC $1000,y   Absolute,y
        .DB     $e1,$84,$07     ; SBC ($10,x)   (Indirect,x)
        .DB     $f1,$84,$08     ; SBC ($10),y   (Indirect),y

        .DB     $38,$87,$00     ; SEC           Implied
        .DB     $f8,$8a,$00     ; SED           Implied
        .DB     $78,$8d,$00     ; SEI           Implied

        .DB     $85,$90,$02     ; STA $10       Zero page
        .DB     $95,$90,$03     ; STA $10,x     Zero page,x
        .DB     $8d,$90,$04     ; STA $1000     Absolute
        .DB     $9d,$90,$05     ; STA $1000,x   Absolute,x
        .DB     $99,$90,$06     ; STA $1000,y   Absolute,y
        .DB     $81,$90,$07     ; STA ($10,x)   (Indirect,x)
        .DB     $91,$90,$08     ; STA ($10),y   (Indirect),y

        .DB     $86,$93,$02     ; STX $10       Zero page
        .DB     $96,$93,$0b     ; STX $10,y     Zero page,y (!)
        .DB     $8e,$93,$04     ; STX $1000     Absolute

        .DB     $84,$96,$02     ; STY $10       Zero page
        .DB     $94,$96,$03     ; STY $10,x     Zero page,x
        .DB     $8c,$96,$04     ; STY $1000     Absolute

        .DB     $aa,$99,$00     ; TAX           Implied
        .DB     $a8,$9c,$00     ; TAY           Implied
        .DB     $ba,$9f,$00     ; TSX           Implied
        .DB     $8a,$a2,$00     ; TXA           Implied
        .DB     $9a,$a5,$00     ; TXS           Implied
        .DB     $98,$a8,$00     ; TYA           Implied


; undocumented commands:

        .DB     $07,$ab,$02     ; SLO $10       Zero page
        .DB     $17,$ab,$03     ; SLO $10,x     Zero page,x
        .DB     $0f,$ab,$04     ; SLO $1000     Absolute
        .DB     $1f,$ab,$05     ; SLO $1000,x   Absolute,x
        .DB     $1b,$ab,$06     ; SLO $1000,y   Absolute,y
        .DB     $03,$ab,$07     ; SLO ($10,x)   (Indirect,x)
        .DB     $13,$ab,$08     ; SLO ($10),y   (Indirect),y

        .DB     $27,$ae,$02     ; RLA $10       Zero page
        .DB     $37,$ae,$03     ; RLA $10,x     Zero page,x
        .DB     $2f,$ae,$04     ; RLA $1000     Absolute
        .DB     $3f,$ae,$05     ; RLA $1000,x   Absolute,x
        .DB     $3b,$ae,$06     ; RLA $1000,y   Absolute,y
        .DB     $23,$ae,$07     ; RLA ($10,x)   (Indirect,x)
        .DB     $33,$ae,$08     ; RLA ($10),y   (Indirect),y

        .DB     $47,$b1,$02     ; SRE $10       Zero page
        .DB     $57,$b1,$03     ; SRE $10,x     Zero page,x
        .DB     $4f,$b1,$04     ; SRE $1000     Absolute
        .DB     $5f,$b1,$05     ; SRE $1000,x   Absolute,x
        .DB     $5b,$b1,$06     ; SRE $1000,y   Absolute,y
        .DB     $43,$b1,$07     ; SRE ($10,x)   (Indirect,x)
        .DB     $53,$b1,$08     ; SRE ($10),y   (Indirect),y

        .DB     $67,$b4,$02     ; RRA $10       Zero page
        .DB     $77,$b4,$03     ; RRA $10,x     Zero page,x
        .DB     $6f,$b4,$04     ; RRA $1000     Absolute
        .DB     $7f,$b4,$05     ; RRA $1000,x   Absolute,x
        .DB     $7b,$b4,$06     ; RRA $1000,y   Absolute,y
        .DB     $63,$b4,$07     ; RRA ($10,x)   (Indirect,x)
        .DB     $73,$b4,$08     ; RRA ($10),y   (Indirect),y

        .DB     $87,$b7,$02     ; SAX $10       Zero page
        .DB     $97,$b7,$0b     ; SAX $10,y     Zero page,y (!)
        .DB     $8f,$b7,$04     ; SAX $1000     Absolute
        .DB     $83,$b7,$07     ; SAX ($10,x)   (Indirect,x)

        .DB     $a7,$ba,$02     ; LAX $10       Zero page
        .DB     $b7,$ba,$0b     ; LAX $10,y     Zero page,y
        .DB     $af,$ba,$04     ; LAX $1000     Absolute
        .DB     $bf,$ba,$05     ; LAX $1000,y   Absolute,y
        .DB     $a3,$ba,$07     ; LAX ($10,x)   (Indirect,x)
        .DB     $b3,$ba,$08     ; LAX ($10),y   (Indirect),y

        .DB     $c7,$bd,$02     ; DCP $10       Zero page
        .DB     $d7,$bd,$03     ; DCP $10,x     Zero page,x
        .DB     $cf,$bd,$04     ; DCP $1000     Absolute
        .DB     $df,$bd,$05     ; DCP $1000,x   Absolute,x
        .DB     $db,$bd,$06     ; DCP $1000,y   Absolute,y
        .DB     $c3,$bd,$07     ; DCP ($10,x)   (Indirect,x)
        .DB     $d3,$bd,$08     ; DCP ($10),y   (Indirect),y

        .DB     $e7,$c0,$02     ; ISB $10       Zero page
        .DB     $f7,$c0,$03     ; ISB $10,x     Zero page,x
        .DB     $ef,$c0,$04     ; ISB $1000     Absolute
        .DB     $ff,$c0,$05     ; ISB $1000,x   Absolute,x
        .DB     $fb,$c0,$06     ; ISB $1000,y   Absolute,y
        .DB     $e3,$c0,$07     ; ISB ($10,x)   (Indirect,x)
        .DB     $f3,$c0,$08     ; ISB ($10),y   (Indirect),y

        .DB     $02,$c3,$00     ; JAM           Implied

        .DB     $89,$66,$01     ; NOP #$10      Immediate
        .DB     $04,$66,$02     ; NOP $10       Zero page
        .DB     $f4,$66,$03     ; NOP $10,x     Zero page,x
        .DB     $0c,$66,$04     ; NOP $1000     Absolute
        .DB     $fc,$66,$05     ; NOP $1000,x   Absolute,x

        .DB     $93,$c6,$08     ; SHA ($10),y   (Indirect),y
        .DB     $9f,$c6,$06     ; SHA $1000,y   Absolute,y
        .DB     $9b,$c9,$06     ; SHS $1000,y   Absolute,y
        .DB     $bb,$cc,$06     ; LAS $1000,y   Absolute,y

        .DB     $0b,$cf,$01     ; ANC #$10      Immediate
        .DB     $4b,$d2,$01     ; ASR #$10      Immediate
        .DB     $6b,$d5,$01     ; ARR #$10      Immediate
        .DB     $8b,$d8,$01     ; ANE #$10      Immediate
        .DB     $ab,$db,$01     ; LXA #$10      Immediate
        .DB     $cb,$de,$01     ; SBX #$10      Immediate


; assembly mnemonics:

        .DB     "???"           ; $00
        .DB     "ADC"           ; $03
        .DB     "AND"           ; $06
        .DB     "ASL"           ; $09

        .DB     "BCC"           ; $0c
        .DB     "BCS"           ; $0f
        .DB     "BEQ"           ; $12
        .DB     "BIT"           ; $15

        .DB     "BMI"           ; $18
        .DB     "BNE"           ; $1b
        .DB     "BPL"           ; $1e
        .DB     "BRK"           ; $21

        .DB     "BVC"           ; $24
        .DB     "BVS"           ; $27
        .DB     "CLC"           ; $2a
        .DB     "CLD"           ; $2d

        .DB     "CLI"           ; $30
        .DB     "CLV"           ; $33
        .DB     "CMP"           ; $36
        .DB     "CPX"           ; $39

        .DB     "CPY"           ; $3c
        .DB     "DEC"           ; $3f
        .DB     "DEX"           ; $42
        .DB     "DEY"           ; $45

        .DB     "EOR"           ; $48
        .DB     "INC"           ; $4B
        .DB     "INX"           ; $4E
        .DB     "INY"           ; $51

        .DB     "JMP"           ; $54
        .DB     "JSR"           ; $57
        .DB     "LDA"           ; $5a
        .DB     "LDX"           ; $5d

        .DB     "LDY"           ; $60
        .DB     "LSR"           ; $63
        .DB     "NOP"           ; $66
        .DB     "ORA"           ; $69

        .DB     "PHA"           ; $6c
        .DB     "PHP"           ; $6f
        .DB     "PLA"           ; $72
        .DB     "PLP"           ; $75

        .DB     "ROL"           ; $78
        .DB     "ROR"           ; $7b
        .DB     "RTI"           ; $7e
        .DB     "RTS"           ; $81

        .DB     "SBC"           ; $84
        .DB     "SEC"           ; $87
        .DB     "SED"           ; $8a
        .DB     "SEI"           ; $8d

        .DB     "STA"           ; $90
        .DB     "STX"           ; $93
        .DB     "STY"           ; $96
        .DB     "TAX"           ; $99

        .DB     "TAY"           ; $9c
        .DB     "TSX"           ; $9f
        .DB     "TXA"           ; $a2
        .DB     "TXS"           ; $a5

        .DB     "TYA"           ; $a8


; assembly mnemonics for undocumented commands:

        .DB     "SLO"           ; $ab
        .DB     "RLA"           ; $ae
        .DB     "SRE"           ; $b1
        .DB     "RRA"           ; $b4

        .DB     "SAX"           ; $b7
        .DB     "LAX"           ; $ba
        .DB     "DCP"           ; $bd
        .DB     "ISB"           ; $c0

        .DB     "JAM"           ; $c3
        .DB     "SHA"           ; $c6
        .DB     "SHS"           ; $c9
        .DB     "LAS"           ; $cc

        .DB     "ANC"           ; $cf
        .DB     "ASR"           ; $d2
        .DB     "ARR"           ; $d5
        .DB     "ANE"           ; $d8
        .DB     "LXA"           ; $db
        .DB     "SBX"           ; $de
